VERSION 5.00
Begin VB.Form MinWind 
   Caption         =   "SizeWind"
   ClientHeight    =   1860
   ClientLeft      =   3510
   ClientTop       =   3765
   ClientWidth     =   3600
   LinkTopic       =   "Form1"
   ScaleHeight     =   1860
   ScaleWidth      =   3600
   Begin VB.OptionButton optPlacement 
      Caption         =   "Restore"
      Height          =   255
      Index           =   2
      Left            =   360
      TabIndex        =   5
      Top             =   1440
      Width           =   1695
   End
   Begin VB.OptionButton optPlacement 
      Caption         =   "Maximize"
      Height          =   255
      Index           =   1
      Left            =   360
      TabIndex        =   4
      Top             =   1080
      Width           =   1695
   End
   Begin VB.OptionButton optPlacement 
      Caption         =   "Minimize"
      Height          =   255
      Index           =   0
      Left            =   360
      TabIndex        =   3
      Top             =   720
      Value           =   -1  'True
      Width           =   1695
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   375
      Left            =   2760
      TabIndex        =   2
      Top             =   840
      Width           =   735
   End
   Begin VB.TextBox txtTargetName 
      Height          =   285
      Left            =   720
      TabIndex        =   1
      Text            =   "WordPad"
      Top             =   240
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "Task"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   495
   End
End
Attribute VB_Name = "MinWind"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hwnd As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function IsWindowVisible Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetDesktopWindow Lib "user32" () As Long
Private Declare Function GetWindow Lib "user32" (ByVal hwnd As Long, ByVal wCmd As Long) As Long
Private Const GW_HWNDFIRST = 0
Private Const GW_HWNDLAST = 1
Private Const GW_HWNDNEXT = 2
Private Const GW_HWNDPREV = 3
Private Const GW_OWNER = 4
Private Const GW_CHILD = 5

Private Type POINTAPI
    X As Long
    Y As Long
End Type
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Private Type WINDOWPLACEMENT
    length As Long
    flags As Long
    showCmd As Long
    ptMinPosition As POINTAPI
    ptMaxPosition As POINTAPI
    rcNormalPosition As RECT
End Type
Private Declare Function GetWindowPlacement Lib "user32" (ByVal hwnd As Long, lpwndpl As WINDOWPLACEMENT) As Long
Private Declare Function SetWindowPlacement Lib "user32" (ByVal hwnd As Long, lpwndpl As WINDOWPLACEMENT) As Long
Private Const SW_SHOWMINIMIZED = 2
Private Const SW_SHOWMAXIMIZED = 3
Private Const SW_SHOWNORMAL = 1
' Return True if this is a top level window.
Private Function IsTopLevelWindow(ByVal app_hwnd As Long) As Boolean
    ' Assume the window is not top level.
    IsTopLevelWindow = False

    ' See if the window's text is blank.
    If Len(WindowText(app_hwnd)) = 0 Then Exit Function

    ' See if the window is visible.
    If IsWindowVisible(app_hwnd) = 0 Then Exit Function

    ' See if the window has an owner.
    If GetWindow(app_hwnd, GW_OWNER) <> 0& Then Exit Function

    ' The window has non-blank text, is visible, and has
    ' no owner so it is (probably) a top level window.
    IsTopLevelWindow = True
End Function
' Return the window's text.
Private Function WindowText(ByVal app_hwnd As Long) As String
Dim text_len As Long
Dim window_text As String

    text_len = GetWindowTextLength(app_hwnd)
    window_text = Space$(text_len + 1)

    text_len = GetWindowText(app_hwnd, window_text, text_len + 1)
    WindowText = Left$(window_text, text_len)
End Function

' Find the target window and minimize, maximize,
' or restore it.
Private Sub cmdGo_Click()
Dim action As Long
Dim target As String
Dim app_hwnd As Long
Dim wp As WINDOWPLACEMENT

    ' Set the appropriate action.
    If optPlacement(0).Value Then
        ' Minimize.
        action = SW_SHOWMINIMIZED
    ElseIf optPlacement(1).Value Then
        ' Maximize.
        action = SW_SHOWMAXIMIZED
    Else
        ' Restore.
        action = SW_SHOWNORMAL
    End If

    ' Get the first window.
    target = txtTargetName.Text
    app_hwnd = GetWindow(GetDesktopWindow(), GW_CHILD)

    ' Examine the windows.
    Do While app_hwnd <> 0&
        ' See if this is a top level window.
        If IsTopLevelWindow(app_hwnd) Then
            ' See if the window's text has the target in it.
            If InStr(WindowText(app_hwnd), target) > 0 Then
                ' Get the window's current placement.
                wp.length = Len(wp)
                GetWindowPlacement app_hwnd, wp

                ' Perform the action.
                wp.showCmd = action
                SetWindowPlacement app_hwnd, wp
            End If
        End If

        ' Get the next window.
        app_hwnd = GetWindow(app_hwnd, GW_HWNDNEXT)
    Loop
End Sub


